#!/bin/bash

# Creamos TMPDIR unico, borrando previamente los anteriores
rm -rf /tmp/rdor-t1-??????
TMPDIR=$( mktemp -d /tmp/rdor-t1-XXXXXX )
chmod 755 $TMPDIR
B="$TMPDIR/comprueba-rdor1"
SEP="------------------------------------------------------------------"

mkdir -p $TMPDIR
rm -rf $TMPDIR/*


echo "unzip -o -d $TMPDIR rdor*.zip"
unzip -o -d $TMPDIR data/rdor*.zip
#cp rdor1-0/trabajo1.* /tmp/.rdor1/rdor1-0/

SCENARIO=$( ls $TMPDIR/rdor1*/*.xml | grep -v conf)
#if [ -e "/usr/local/local/bin/configura-tap" ]
#then
#  CONFIGURA="sudo /usr/local/local/bin/configura-tap"
#else
#  CONFIGURA=$( ls $TMPDIR/rdor1*/*tap )
#fi

# Creamos script comprueba-rdor1
cat > $B << "FIN-B"
#!/bin/bash

echo "Comprobando hosts..."
HOSTS="H1 H2 H3 H4"
echo $HOSTS

for r in $HOSTS; do
  echo -n "Host $r: "
  counter=3
  while true
  do
    #ss=$( nmap -p 22 $r | grep ssh) > /dev/null
    ss=$( sudo lxc-info -n $r -s -H ) 
    #echo "** $r -> $ss"
    if [ "$ss" != "RUNNING" ]; then
          if [ $counter -eq 0 ]; then
            echo " ERROR"
            FALLOS="$FALLOS $r"
            break
          else
            echo -n "."
            counter=$(( $counter -1 ))
            sleep 3
          fi
    else
          echo "arrancado"
          break
    fi
  done
done

echo "Comprobando routers..."
ROUTERS="A B C"
echo $ROUTERS

for r in $ROUTERS; do
  echo -n "Router $r: "
  counter=3
  while true
  do
    #ss=$( nmap -p 22 $r | grep ssh) > /dev/null
    ss=$( sudo lxc-info -n $r -s -H ) 
    if [ "$ss" != "RUNNING" ]; then
          if [ $counter -eq 0 ]; then
            echo " ERROR"
            FALLOS="$FALLOS $r"
            break
          else
            echo -n "."
            counter=$(( $counter -1 ))
            sleep 3
          fi
    else
          echo "arrancado"
          break
    fi
  done
done


echo $SEP
if [ "$FALLOS" = "" ]; then
    echo "Escenario arrancado correctamente."
else
    echo "ERROR: algunos sistemas no arrancaron correctamente ($FALLOS )"
    echo "       Rearranque el escenario de nuevo"
fi
echo $SEP

FIN-B

function limpia () {

# Hacemos limpieza primero...
PIDS=$( ps uaxww | grep "comprueba-rdor1" | grep -v grep | awk '{ print $2 }' )
if [ "$PIDS" ]; then
    echo "Matando procesos comprueba-rdor1:" $PIDS
    sudo kill -9 $PIDS
else
    echo "No hay procesos comprueba-rdor1"
fi

PIDS=$( ps uaxww | grep "nmap" | grep -v grep | awk '{ print $2 }' )
if [ "$PIDS" ]; then
    echo "Matando procesos nmap:" $PIDS
    sudo kill -9 $PIDS
else
    echo "No hay procesos nmap"
fi

#sudo vnx -D
sudo vnx -f $SCENARIO -v -P -D

}

( limpia; $CONFIGURA; sudo vnx -f $SCENARIO -v -t; echo ''; echo "$SEP"; echo ''; sleep 2; sh $B; echo "$SEP"; ) | yad --text-info --tail --title 'Arrancando escenario 1 RDOR...' --height 400 --width 800 --fontname="Monospace 7" --wrap &

#xterm -title 'Escenario OSPF' -geometry 100x40 \
#      -e "sudo vnx -f $SCENARIO -v -t; echo ''; echo '$SEP'; echo ''; sh $B; echo '$SEP'; echo 'Press <return> to close this window'; echo '$SEP'; bash" 



